require "hump.vector"
--small speed up
g = love.graphics
a = love.audio

--const
gravity = vector(0,0.7)


--counter
counter = 0

-------------------------
-------------------------
-------Love Callbacks----
-------------------------
function love.load()
	--set mode and graphics
	g.setMode(300,500)
	g.setFont(g.newFont(40))

	--kick sound
	click = a.newSource("Clic03.mp3")

	--musi
	music = a.newSource("dynamithagda.mp3")
	music:setLooping(true)
	music:setVolume(.2)
	a.play(music)

	--init ball
	init_ball()
	-- background image
	backgroundImage = g.newImage("bck.jpg")
end


function love.update(dt)
	-- update ball position
	updateBall(dt)
end

function love.draw()
	-- draw bg
	g.draw(backgroundImage,0,0)
	-- draw kick counter
	g.print( counter ,250,0)
	-- draw ball
	ball.draw()
end


function love.mousepressed(x, y, button)
   if button == 'l' then

      local vec = vector(ball.position.x-x,ball.position.y-y)

	  if vec:len() < 48 then
		-- make kick happen
			vec.y = vec.y -10
			vec.x = vec.x / 2
			vec = vec:normalized()*15
			ball.speed = vec
			counter = counter + 1
			a.play(click)
			changeBallRotation()
	  end

   end
end

----------------------------------------------------ball

-- basic ball init
function init_ball()
	ball = { r = 48 , position = vector(150,250),speed = vector(4,-10) ,rotation =0 , rotation_speed =0 }
	ball.image = g.newImage("ball.png")
	ball.draw = function() g.draw(ball.image,ball.position.x,ball.position.y,ball.rotation,1,1,48,48) end

end

function updateBall(dt)
	-- change speed vector
	ball.speed = ball.speed + gravity
	-- update position
	ball.position = ball.position + ball.speed*dt*30
	-- update rotation
	ball.rotation = ball.rotation+ball.rotation_speed

	if ball.position.y + ball.r >= 500 then
		-- colision with floor
		ball.position.y = 452;
		counter = 0
		if math.abs(ball.speed.y) > 0  then
			ball.speed = vector(ball.speed.x*0.7,-ball.speed.y*0.9)
		end
		if math.abs(ball.speed.y) > 0.5 then
			changeBallRotation()
		else
			ball.rotation_speed = 0
		end
	end

	if ball.position.x - ball.r < 0 then
		-- colision with left wall
		-- move ball back only if it is heading outside
		if ( ball.speed.x < 0 ) then
			ball.position.x = 49
		end

		ball.speed = vector(-ball.speed.x,ball.speed.y)
		changeBallRotation()
	elseif ball.position.x+ball.r > 300 then
		-- colision with right wall
		-- move ball back only if it is heading outside
		if ( ball.speed.x > 0 ) then
			ball.position.x = 250
		end

		ball.speed = vector(-ball.speed.x,ball.speed.y)
		changeBallRotation()
	end

end

function changeBallRotation()
		ball.rotation_speed =  math.pi * (math.random()-0.5)/20

end
